/*!
 * @file		AddUserDlg.h
 * @brief		 ߰ ȭ(, ȭâ  ߰ )
 * @author		Jinwoo.Lee(jinwoo.lee@nhn.com)
 * @date		2012-04-14 
 * @warning
 * @attention	Copyright 2012 NTS Corp. All rights reserved.
 */
#pragma once
#include "NListCtrlEx.h"
#include "InfoSearchWnd.h"
#include "AddUserListData.h"

#define ADD_USER_DLG_BTN_WIDTH		80
#define ADD_USER_DLG_BTN_HEIGHT		28
#define ADD_USER_DLG_BTN_GAP_X		4

#define ID_ADD_USER_SEARCH			(0xE101)

class WorkGroupController;
class WorkGroupModel;

class CAddUserDlg : public CDialog
{
	DECLARE_DYNAMIC(CAddUserDlg)

	struct SORTPARAM
	{
		int nSortColumn;
		bool bSortAscending;
	};

public:
	CAddUserDlg(WorkGroupController* pController, WorkGroupModel* pModel, CWnd* pParent, int nType = 1);
	virtual ~CAddUserDlg();

	enum { IDD = IDD_ADD_USER_DLG };

	void	InitMemberList();
	void	UpdateMemberStatus(LPCWSTR strUserId);
	void	ChangeMyStatus(GTUserStatusType eMyStatus);
	void	__ResourceLoad(BOOL bInit = FALSE);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL PreTranslateMessage(MSG* pMsg);	
	void	OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult);
	static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnNMDblclkListUser(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickListUser(NMHDR *pNMHDR, LRESULT *pResult);

	LRESULT OnGetUserStatus(WPARAM wParam,LPARAM lParam);

	DECLARE_MESSAGE_MAP()

private:
	void	SetSkin();
	void	ReSizeCtrl();
	void	InitList(CNListCtrl &list, CStringArray &strHeaderTitle);
	void	ResizeListColumn(CNListCtrl &list, const int *arrWidth);
	void	DoSearch(CString strSearchText);
	void	FreeListData();
	bool	IsCloseMsg(MSG* pMsg);
	bool	SendUserListToParent();

	WorkGroupController* m_pController;
	WorkGroupModel* m_pModel;

	CImageList		m_ImageList;
	CImageList		m_ImageListWorkStatus;
	CNListCtrlEx		m_lcUser;
	CInfoSearchWnd	m_wndSearch;	// ˻â
	CBitmap			m_bmTopBg;
	CPen			m_penBorder;
	CString			m_strSearchText;
	CButton			m_bnOK;
	CButton			m_bnCancel;
	std::vector<CAddUserListData *> m_userDataVector;
	CStringArray m_arListHeaderTitle;
	int				m_nParentType;
	bool			m_bSortAscending;
	CWnd*			m_pParent;

};
